#include <avr/io.h>
#include <util/delay.h>

//Mention Clock frequency here
#define _XTAL_FREQ 8000000

// structure to allow bit field operations, name conversions: PORTA.0 -> PORT_A.b0  PORTB.7 -> PORT_B.b7
typedef struct{ uint8_t b0:1;
	uint8_t b1:1;
	uint8_t b2:1;
	uint8_t b3:1;
	uint8_t b4:1;
	uint8_t b5:1;
	uint8_t b6:1;
uint8_t b7:1; } bits;

// define all the ports of your microcontroller, add more ports depending on the available mcu ports
#define PORT_A (* (volatile bits *) &PORTA)
#define PIN_A (* (volatile bits *) &PINA)
#define DDR_A (* (volatile bits *) &DDRA)

#define PORT_B (* (volatile bits *) &PORTB)
#define PIN_B (* (volatile bits *) &PINB)
#define DDR_B (* (volatile bits *) &DDRB)

#define lcd_data_pin  PORTD
#define en  PORT_A.b0
#define rs  PORT_A.b1
#define rw  PORT_A.b2


void lcd_init();
void lcd_data(unsigned char data1);
void lcd_cmd(unsigned char cmd);
void lcd_control(unsigned char cmdordata);
void lcd_string(unsigned char *str);


void lcd_init(){
	
	lcd_cmd(0x38);
	_delay_ms(150);
	lcd_cmd(0x0E);
	_delay_ms(150);
	lcd_cmd(0x01);
	_delay_ms(150);
	lcd_cmd(0x06);
	_delay_ms(150);
	lcd_cmd(0x0C);
	_delay_ms(150);
	lcd_cmd(0x80);
	
}

void lcd_data(unsigned char data1)
{
	
	lcd_data_pin = data1;
	lcd_control(2);
	
	
}

void lcd_cmd(unsigned char cmd){
	
	lcd_data_pin = cmd;
	lcd_control(1);
}

void lcd_control(unsigned char cmdordata){
	
	if(cmdordata == 1){
		rs=0;
		rw=0;
		en=1;
		_delay_ms(5);
		en=0;
	}
	else if(cmdordata == 2){
		rs=1;
		rw=0;
		en=1;
		_delay_ms(5);
		en=0;
	}
}

void lcd_string(unsigned char *str){
	
	while(*str){
		lcd_data(*str++);
	}
	
}


unsigned char msg[20] = "Working?";

int main(){
	
	
	
	DDRA = 0xFF;
	DDRD = 0xFF;
	
	lcd_init();
	lcd_data('A');
	lcd_cmd(0xC0);
	lcd_string(msg);
	
	while(1){
		
		;
		
	}
	
	return (0);
}